package com.geobioboo.twitterproj2;

import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

import twitter4j.IDs;
import twitter4j.ResponseList;
import twitter4j.Twitter;
import twitter4j.TwitterFactory;
import twitter4j.User;

public class Following {
	
	/**
	 * saves the username and tweets of people im following
	 */
	public static void main(String[] args) throws Exception {
		
		final Twitter twitter = new TwitterFactory().getInstance();
		
		final IDs user1ids = twitter.getFriendsIDs(-1);
		final long[] following = user1ids.getIDs(); // all people im following
		
		long[] oneHundredUsers = new long[100];;
		ArrayList<User> allUserResults = new ArrayList<User>();
		
		// adds each user to an array, and every 100 users, look it up against twitter api,
		// and save those users into allUserResults arraylist.
        for (int i = 0; i < following.length; i++) {
        	oneHundredUsers[i % 100] = following[i];
        	if (i == following.length - 1 || i % 100 == 99) { // every 100 users, or at end
        		ResponseList<User> oneHundredUsersResult = twitter.lookupUsers(oneHundredUsers);
        		oneHundredUsers = new long[100];
        		allUserResults.addAll(oneHundredUsersResult);
        	}
        }
        
        for (User u : allUserResults) {
        	String status = u.getStatus() != null ? u.getStatus().getText() : "";
        	status = status.replaceAll("\n", " ");
        	status = status.replaceAll("\r", " ");
        	write(u.getScreenName() + "\t" + status + "\n");
        }
        endWrite();
	}
	
	static FileWriter fw;
    
    private static void write(String s) {
    	try {
    		if (fw == null)
    			fw = new FileWriter("myfollowing.txt", false);
    		fw.write(s);
    	} catch (IOException e) {}
    }
    
    private static void endWrite() {
    	try {
    		fw.close();
    	} catch (IOException e) {}
    }

}